import type { Inertia } from '@inertiajs/inertia';
import type { Router, Config, RouteParam, RouteParamsWithQueryOverload } from 'ziggy-js';
import { InertiaLink, install } from './link';
import type { Page } from '@inertiajs/core';
/**
 * Get head manager instance
 */
export declare function useHeadManager(): any;
/**
 * Get page instance
 *
 * @deprecated use \@inertiajs/vue2's usePage().
 */
export declare function usePage<SharedProps = Record<string, any>>(): Page<SharedProps>;
/**
 * Get inertia instance
 */
export declare function useInertia(): typeof Inertia;
/**
 * Get Form
 *
 * @param data - Form Key-Value Pair.
 * @param rememberKey - Cancel token
 *
 * @deprecated use \@inertiajs/vue2's useForm()
 */
export declare function useForm<TForm = Record<string, any>>(data: TForm, rememberKey?: string): TForm;
/**
 * Get route instance.
 *
 * @param name - router name.
 * @param params - query strings key value pair.
 * @param absolute - return to absolute url flag.
 * @param config - override confing. (Host, Port, etc.)
 */
export declare function route(name?: string, params?: RouteParamsWithQueryOverload | RouteParam, absolute?: boolean, config?: Config): string | Router;
export { InertiaLink, install };
//# sourceMappingURL=index.d.ts.map